/*
 * This Java source file is completely Free and Open-Source, 
 * released under the MIT License.
 *
 * Copyright (2012) Ashish Nawal Saharia (ashish.saharia@yahoo.co.in)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.dbcp.secure;

/**
 *
 * @author Ashish (ashish.saharia@yahoo.co.in)
 */
public class DBServerConfig
{
    
    private String poolIdentifier = null;
    private String dbDriverClassName;
    private String dbServer;
    private String dbServerPort;
    private String dbInstance;
    private String dbUsername;
    private String dbPassword;
    private String dbConnectionString;

    private int maxPoolSize;
    private int maxWait;        

    /**
     * @return the poolIdentifier
     */
    public String getPoolIdentifier()
    {
        return poolIdentifier;
    }

    /**
     * @param poolIdentifier the poolIdentifier to set
     */
    public void setPoolIdentifier(String poolIdentifier)
    {
        this.poolIdentifier = poolIdentifier;
    }

    /**
     * @return the dbDriverClassName
     */
    public String getDbDriverClassName()
    {
        return dbDriverClassName;
    }

    /**
     * @param dbDriverClassName the dbDriverClassName to set
     */
    public void setDbDriverClassName(String dbDriverClassName)
    {
        this.dbDriverClassName = dbDriverClassName;
    }

    /**
     * @return the dbServer
     */
    public String getDbServer()
    {
        return dbServer;
    }

    /**
     * @param dbServer the dbServer to set
     */
    public void setDbServer(String dbServer)
    {
        this.dbServer = dbServer;
    }

    /**
     * @return the dbServerPort
     */
    public String getDbServerPort()
    {
        return dbServerPort;
    }

    /**
     * @param dbServerPort the dbServerPort to set
     */
    public void setDbServerPort(String dbServerPort)
    {
        this.dbServerPort = dbServerPort;
    }

    /**
     * @return the dbInstance
     */
    public String getDbInstance()
    {
        return dbInstance;
    }

    /**
     * @param dbInstance the dbInstance to set
     */
    public void setDbInstance(String dbInstance)
    {
        this.dbInstance = dbInstance;
    }

    /**
     * @return the dbUsername
     */
    public String getDbUsername()
    {
        return dbUsername;
    }

    /**
     * @param dbUsername the dbUsername to set
     */
    public void setDbUsername(String dbUsername)
    {
        this.dbUsername = dbUsername;
    }

    /**
     * @return the dbPassword
     */
    public String getDbPassword()
    {
        return dbPassword;
    }

    /**
     * @param dbPassword the dbPassword to set
     */
    public void setDbPassword(String dbPassword)
    {
        this.dbPassword = dbPassword;
    }

    /**
     * @return the dbConnectionString
     */
    public String getDbConnectionString()
    {
        return dbConnectionString;
    }

    /**
     * @param dbConnectionString the dbConnectionString to set
     */
    public void setDbConnectionString(String dbConnectionString)
    {
        this.dbConnectionString = dbConnectionString;
    }

    /**
     * @return the maxPoolSize
     */
    public int getMaxPoolSize()
    {
        return maxPoolSize;
    }

    /**
     * @param maxPoolSize the maxPoolSize to set
     */
    public void setMaxPoolSize(int maxPoolSize)
    {
        this.maxPoolSize = maxPoolSize;
    }

    /**
     * @return the maxWait
     */
    public int getMaxWait()
    {
        return maxWait;
    }

    /**
     * @param maxWait the maxWait to set
     */
    public void setMaxWait(int maxWait)
    {
        this.maxWait = maxWait;
    }
    
}
