/*
 * This Java source file is completely Free and Open-Source, 
 * released under the MIT License.
 *
 * Copyright (2012) Ashish Nawal Saharia (ashish.saharia@yahoo.co.in)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */


/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.nlp.chat;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Ashish (ashish.saharia@yahoo.co.in)
 */
public class ChatContext
{
   
    private long chatId = -1L;
    private List<ChatMessage> messages = new ArrayList<>(); 
    private String fullChat = null;

    /**
     * @return the chatId
     */
    public long getChatId()
    {
        return chatId;
    }

    /**
     * @param chatId the chatId to set
     */
    public void setChatId(long chatId)
    {
        this.chatId = chatId;
    }

    /**
     * @return the messages
     */
    public List<ChatMessage> getMessages()
    {
        return messages;
    }

    /**
     * @param messages the messages to set
     */
    public void setMessages(List<ChatMessage> messages)
    {
        this.messages = messages;
    }
    
    /**
     * @return the fullChat
     */
    public String getFullChat()
    {
        return fullChat;
    }

    /**
     * @param fullChat the fullChat to set
     */
    public void setFullChat(String fullChat)
    {
        this.fullChat = fullChat;
    }

    public void freezeChat()
    {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < messages.size(); ++i)
        {
            sb.append(messages.get(i));
        }
        fullChat = sb.toString();
    }
    
}
