/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.nlp.ner;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.regex.Pattern;
import net.infantai.nlp.RegExTagger;
import net.infantai.nlp.ner.EntityTaggerOutput;

/**
 *
 * @author Ashish
 */
public class AgeTaggerRegEx extends RegExTagger
{
    
    private List<String> textToDiscardFromBeginning = new ArrayList<>();
    private List<String> textToDiscardFromEnd = new ArrayList<>();
    
    public AgeTaggerRegEx()
    {
        textToDiscardFromBeginning.add("aged"); // don't change the order in which these are stacked!
        textToDiscardFromBeginning.add("age");
        
        textToDiscardFromEnd.add("woman"); // don't change the order in which these are stacked!
        textToDiscardFromEnd.add("female");        
        textToDiscardFromEnd.add("man");
        textToDiscardFromEnd.add("male");
        textToDiscardFromEnd.add("boy");
        textToDiscardFromEnd.add("girl");
        textToDiscardFromEnd.add("child");
        textToDiscardFromEnd.add("baby");
        textToDiscardFromEnd.add("infant");
        textToDiscardFromEnd.add("patient");
        textToDiscardFromEnd.add("pre term");
        textToDiscardFromEnd.add("preterm");
        textToDiscardFromEnd.add("premature");
        textToDiscardFromEnd.add("/"); // experimental
        textToDiscardFromEnd.add(")"); // experimental
        textToDiscardFromEnd.add(","); // experimental
    }
    
    public List<EntityTaggerOutput> getAges(String input)    
    {
        List<String> ageMarkers = new ArrayList<>();
        ageMarkers.add("? yom");
        ageMarkers.add("? yow");
        ageMarkers.add("? yof");
        ageMarkers.add("?/male");
        ageMarkers.add("?/female");        

//        ageMarkers.add("? year old man");
//        ageMarkers.add("? years old man");            
//        ageMarkers.add("? yr. old man");            
//        ageMarkers.add("? yr old man");            
//        ageMarkers.add("? yrs. old man");
//        ageMarkers.add("? yrs old man");
//        ageMarkers.add("? yo man");
//        ageMarkers.add("? yom");
//        ageMarkers.add("? year old male");
//        ageMarkers.add("? years old male");            
//        ageMarkers.add("? yr. old male");            
//        ageMarkers.add("? yr old male");
//        ageMarkers.add("? yrs. old male");
//        ageMarkers.add("? yrs old male");            
//        ageMarkers.add("? yo male");            
//        ageMarkers.add("? year old boy");
//        ageMarkers.add("? years old boy");            
//        ageMarkers.add("? yr. old boy");            
//        ageMarkers.add("? yr old boy");
//        ageMarkers.add("? yrs. old boy");
//        ageMarkers.add("? yrs old boy");            
//        ageMarkers.add("? yo boy"); 
//        ageMarkers.add("? year old child");
//        ageMarkers.add("? years old child");            
//        ageMarkers.add("? yr. old child");            
//        ageMarkers.add("? yr old child");
//        ageMarkers.add("? yrs. old child");
//        ageMarkers.add("? yrs old child");            
//        ageMarkers.add("? yo child");
//        ageMarkers.add("? year old woman");
//        ageMarkers.add("? years old woman");            
//        ageMarkers.add("? yr. old woman");            
//        ageMarkers.add("? yr old woman");            
//        ageMarkers.add("? yrs. old woman");
//        ageMarkers.add("? yrs old woman");            
//        ageMarkers.add("? yo woman");            
//        ageMarkers.add("? yow");       
//        ageMarkers.add("? year old female");
//        ageMarkers.add("? years old female");            
//        ageMarkers.add("? yr. old female");            
//        ageMarkers.add("? yr old female");            
//        ageMarkers.add("? yrs. old female");
//        ageMarkers.add("? yrs old female");                        
//        ageMarkers.add("? yo female");             
//        ageMarkers.add("? yof");             
//        ageMarkers.add("? year old girl");
//        ageMarkers.add("? years old girl");            
//        ageMarkers.add("? yr. old girl");            
//        ageMarkers.add("? yr old girl");
//        ageMarkers.add("? yrs. old girl");
//        ageMarkers.add("? yrs old girl");            
//        ageMarkers.add("? yo girl");             
//        ageMarkers.add("? month old baby");
//        ageMarkers.add("? months old baby");
//        ageMarkers.add("? mth old baby");
//        ageMarkers.add("? mths old baby");            
//        ageMarkers.add("? month old infant");
//        ageMarkers.add("? months old infant");
//        ageMarkers.add("? mth old infant");
//        ageMarkers.add("? mths old infant");
//
//        ageMarkers.add("? weeks old baby");
//        ageMarkers.add("? week old baby");
//        ageMarkers.add("? wk. old baby");
//        ageMarkers.add("? wk old baby");
//        ageMarkers.add("? weeks old infant");
//        ageMarkers.add("? week old infant");
//        ageMarkers.add("? wk. old infant");            
//        ageMarkers.add("? wk old infant");
//
//        ageMarkers.add("? weeks old preterm");
//        ageMarkers.add("? week old preterm");
//        ageMarkers.add("? wk. old preterm");            
//        ageMarkers.add("? wk old preterm");
//        ageMarkers.add("? weeks old pre term");
//        ageMarkers.add("? week old pre term");
//        ageMarkers.add("? wk. old pre term");            
//        ageMarkers.add("? wk old pre term");            
//        ageMarkers.add("? weeks old premature");
//        ageMarkers.add("? week old premature");
//        ageMarkers.add("? wk. old premature");            
//        ageMarkers.add("? wk old premature");            
//
//
//        ageMarkers.add("? year old patient");
//        ageMarkers.add("? years old patient");            
//        ageMarkers.add("? yr. old patient");            
//        ageMarkers.add("? yr old patient");            
//        ageMarkers.add("? yrs. old patient");
//        ageMarkers.add("? yrs old patient");
//        ageMarkers.add("? yo patient");
//        ageMarkers.add("age ? years");
//        ageMarkers.add("age ? year");
//        ageMarkers.add("age ? yrs");
//        ageMarkers.add("age ? yr");
//        ageMarkers.add("aged ? years");
//        ageMarkers.add("aged ? year");
//        ageMarkers.add("aged ? yrs");
//        ageMarkers.add("aged ? yr");      
//
//        ageMarkers.add("? years male");
//        ageMarkers.add("? year male");
//        ageMarkers.add("? yrs. male");
//        ageMarkers.add("? yrs male");
//        ageMarkers.add("? yr. male");
//        ageMarkers.add("? yr male");
//        ageMarkers.add("? years man");
//        ageMarkers.add("? year man");            
//        ageMarkers.add("? yrs. man");
//        ageMarkers.add("? yrs man");
//        ageMarkers.add("? yr. man");
//        ageMarkers.add("? yr man");
//        ageMarkers.add("? years boy");
//        ageMarkers.add("? year boy");            
//        ageMarkers.add("? yrs. boy");
//        ageMarkers.add("? yrs boy");
//        ageMarkers.add("? yr. boy");
//        ageMarkers.add("? yr boy");
//        ageMarkers.add("? years female");
//        ageMarkers.add("? year female");            
//        ageMarkers.add("? yrs. female");
//        ageMarkers.add("? yrs female");
//        ageMarkers.add("? yr. female");
//        ageMarkers.add("? yr female");            
//        ageMarkers.add("? years woman");
//        ageMarkers.add("? year woman");            
//        ageMarkers.add("? yrs. woman");
//        ageMarkers.add("? yrs woman");
//        ageMarkers.add("? yr. woman");
//        ageMarkers.add("? yr woman");
//        ageMarkers.add("? years girl");
//        ageMarkers.add("? year girl");            
//        ageMarkers.add("? yrs. girl");
//        ageMarkers.add("? yrs girl");
//        ageMarkers.add("? yr. girl");
//        ageMarkers.add("? yr girl");                   

        List<String> ageMarkersForVicinityMatch = new ArrayList<>();     

        ageMarkersForVicinityMatch.add("? year old");
        ageMarkersForVicinityMatch.add("? years old");            
        ageMarkersForVicinityMatch.add("? yr. old");            
        ageMarkersForVicinityMatch.add("? yr old");            
        ageMarkersForVicinityMatch.add("? yrs. old");
        ageMarkersForVicinityMatch.add("? yrs old");
        ageMarkersForVicinityMatch.add("? yo");            
        ageMarkersForVicinityMatch.add("? years");
        ageMarkersForVicinityMatch.add("? year");
        ageMarkersForVicinityMatch.add("? yrs.");
        ageMarkersForVicinityMatch.add("? yrs");
        ageMarkersForVicinityMatch.add("? yr.");
        ageMarkersForVicinityMatch.add("? yr");            

        ageMarkersForVicinityMatch.add("? months old");
        ageMarkersForVicinityMatch.add("? month old");
        ageMarkersForVicinityMatch.add("? mths. old");
        ageMarkersForVicinityMatch.add("? mth. old");                        
        ageMarkersForVicinityMatch.add("? mths old");
        ageMarkersForVicinityMatch.add("? mth old");                                    
        ageMarkersForVicinityMatch.add("? weeks old");
        ageMarkersForVicinityMatch.add("? week old");
        ageMarkersForVicinityMatch.add("? wk. old");
        ageMarkersForVicinityMatch.add("? wk old");            

        ageMarkersForVicinityMatch.add("age ? years");
        ageMarkersForVicinityMatch.add("age ? year");
        ageMarkersForVicinityMatch.add("age ? yrs");
        ageMarkersForVicinityMatch.add("age ? yr");
        ageMarkersForVicinityMatch.add("aged ? years");
        ageMarkersForVicinityMatch.add("aged ? year");
        ageMarkersForVicinityMatch.add("aged ? yrs");
        ageMarkersForVicinityMatch.add("aged ? yr");                  
        ageMarkersForVicinityMatch.add("aged ?");
        ageMarkersForVicinityMatch.add("age ?");

        Pattern pat = buildRegExPatternForQuantities(ageMarkers, true, true);
        List<EntityTaggerOutput> lst = getQuantities(input, pat, textToDiscardFromBeginning, textToDiscardFromEnd);                

        Set<String> vicinityTokens = new HashSet<>();
        vicinityTokens.addAll(textToDiscardFromEnd);            
        Pattern patVicinity = buildRegExPatternForQuantities(ageMarkersForVicinityMatch, true, true);
        List<EntityTaggerOutput> lstVicinity = getQuantities(input, patVicinity, textToDiscardFromBeginning, textToDiscardFromEnd, vicinityTokens, 3);    
        lst.addAll(lstVicinity);

        Collections.sort(lst); // optional

        return lst;
    }
    
    public static void main(String[] args)
    {
        AgeTaggerRegEx mnerTagger = new AgeTaggerRegEx();
//        String input = "Followup of left hand discomfort and systemic lupus 10,000 UNITS/20ML erythematosus.,HISTORY OF PRESENT ILLNESS: , The patient is a 56-year-old female with a history of systemic lupus erythematosus, who was last seen in rheumatology clinic approximately 4 months ago for bilateral hand discomfort, left greater than right.  The patient was seen on 10/30/07.  She had the same complaint.  She was given a trial of Elavil at bedtime because the thought was to see that represented ulnar or radial neuropathy.  She was also given a prescription for Zostrix cream but was unable to get it filled because of insurance coverage.  The patient reports some worsening of the symptoms especially involving at the dorsum of the left hand, and she points to the area that actually involves the dorsal aspect of the second, third, and fourth digits.  The patient recently has developed what sounds like an upper respiratory problem with a nonproductive cough for 3 days, although she reports that she has had subjective fevers for the past 3 or 4 days, but has not actually taken the temperature.  She has not had any night sweats or chills.  She has had no recent problems with chest pain, chest discomfort, shortness of breath or problems with GU or GI complaints.  She is returning today for routine followup evaluation.,CURRENT MEDICATIONS:,1.  Plaquenil 200 mg twice a day.,2.  Fosamax 170 mg once a week.,3.  Calcium and vitamin D complex twice daily.,4.  Folic acid 1 mg per day.,5.  Trilisate 1000 mg a day.,6.  K-Dur 20 mEq twice a day.,7.  Hydrochlorothiazide 15 mg once a day.,8.  Lopressor 50 mg one-half tablet twice a day.,9.  Trazodone 100 mg at bedtime.,10.  Prempro 0.625 mg per day.,11.  Aspirin 325 mg once a day.,12.  Lipitor 10 mg per day.,13.  Pepcid 20 mg twice a day.,14.  Reglan 10 mg before meals and at bedtime.,15.  Celexa 20 mg per day.,REVIEW OF SYSTEMS: , Noncontributory except for what was noted in the HPI and the remainder or complete review of systems is unremarkable.,PHYSICAL EXAMINATION:,VITAL SIGNS:  Blood pressure 155/84, pulse 87, weight 223 pounds, and temperature 99.2.  GENERAL:  She is a well-developed, well-nourished female appearing her staged age.  She is alert, oriented, and cooperative.  HEENT:  Normocephalic and atraumatic.  There is no facial rash.  No oral lesions.  LUNGS:  Clear to auscultation.  CARDIOVASCULAR:  Regular rate and rhythm without murmurs, rubs or gallops.  EXTREMITIES:  No cyanosis or clubbing.  Sensory examination of the upper extremity decreased to light touch on the distal tips of the left second and third digits compared to the fifth digit.  Positive Tinel sign.  Full range of motion of the wrist with no evidence of motor atrophy or muscle loss.,LABORATORY DATA:  ,WBC 5100, hemoglobin 11.1, hematocrit 32.8, and platelets 200,000.  Westergren sedimentation rate of 47.  Urinalysis is negative for protein and blood.  Lupus serology is pending.,ASSESSMENT:,1.  Systemic lupus erythematosus that is chronically stable at this point.,2.  Carpal tunnel involving the left wrist with sensory change, but no evidence of motor change.,3.  Upper respiratory infection with cough, cold, and congestion.,RECOMMENDATIONS:,1.  The patient will have a trial of a resting wrist splint at night for the next 4 to 6 weeks.  If there is no improvement, the patient will return for corticosteroid injection of her carpal tunnel.,2.  Azithromycin 5-day dose pack.,3.  Robitussin Cough and Cold Flu to be taken twice a day.,4.  Atarax 25 mg at bedtime for sleep.,5.  The patient will return to the rheumatology clinic for a routine followup evaluation in 4 months.";
//        String input = "Initially 10–20 mL, calcium gluconate injection 10% (providing approximately 2.25–4.5 mmol of calcium) should be administered with plasma-calcium and ECG monitoring, and either repeated as required or, if only temporary improvement, followed by a continuous intravenous infusion to prevent recurrence, alternatively (by continuous intravenous infusion), initially 50 mL/hour, adjusted according to response, infusion to be administered using 100 mL of calcium gluconate 10% diluted in 1 litre of glucose 5% or sodium chloride 0.9%.";
//        String input = "Pain and swelling in abdomen\n" +
//"Patient is a 67-year-old female presents to the emergency room with sharp, shooting pain in her lower abdomen and pronounced swelling. Patient is nauseous, has vomited, and has a fever. Abdomen is firm and slightly distended. Patient states she has no history of abdominal problems, disease, or hernia.\n" +
//"Patient is on a program of anti-depressants, but is otherwise physically sound. States she has never been admitted for any abdominal problems.\n" +
//"Wellbutrin, 5 mg daily\n" +
//"Used to smoke (using Wellbutrin to quit) and does not drink\n" +
//"Vital Signs: Blood pressure is 150/88, with a fever of 102 degrees.\n" +
//"Skin: Warm and dry and normal, except in lower abdomen, where it is swollen and tight\n" +
//"Chest: no respiratory problems detected\n" +
//"Cardiac: regular rhythm\n" +
//"Back: No abnormalities detected\n" +
//"Abdomen: is firm above the pelvic bones. Patient experiences pain upon palpation. Blumberg sign elicits painful response, as does a forced cough. Abdomen is tight and swollen.\n" +
//"Acute appendicitis";
        String input = "Ashish (65 yrs) male\n" +
"Ashish, 65 yrs, male\n" +
"Ashish, 65 years, male\n" +
"Ashish, 65/male,\n"
                + " 39 year old indian male, Som male age 40, and Madhu, a 33 yr old indian male, 25 yom";
        List<EntityTaggerOutput> lst = mnerTagger.getAges(input);
        for (int i = 0; i < lst.size(); ++i)
        {
            EntityTaggerOutput eto = lst.get(i);
            System.out.println("-------------- Age: " + eto.tg.getToken() + " ----------- index: " + eto.tg.getIndex());
        }
        System.out.println(input);
    }
    
}
