/*
 * This Java source file is completely Free and Open-Source, 
 * released under the MIT License.
 *
 * Copyright (2012) Ashish Nawal Saharia (ashish.saharia@yahoo.co.in)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.util.common;

import java.math.BigInteger;
import java.util.Random;

/**
 *
 * @author Ashish (ashish.saharia@yahoo.co.in)
 */
public class RandomUtil
{
    
    public final Random instanceRandom = new Random();
    
    public long generatePseudoRandomNumber()
    {
        long r = 0;
        r = instanceRandom.nextLong();
        return r;
    }
    
    public static long generatePseudoRandomNumber(Random random)
    {
        long r = 0;
        r = random.nextLong();
        return r;
    }    
    
    public long generatePseudoRandomNumber(long min, long max)
    {
        long r = 0;
        if (min != -1 || max != -1)
        {
            if (min >= max)
            {
                return r;
            }
        }
        r = generatePseudoRandomNumber();
        if (r < 0)
        {
            r = r * -1;
        }
        r = r % (max - min) + min;
        return r;
    }
    
    public static long generatePseudoRandomNumber(long min, long max, Random random)
    {
        long r = 0;
        if (min != -1 || max != -1)
        {
            if (min >= max)
            {
                return r;
            }
        }
        r = generatePseudoRandomNumber(random);
        if (r < 0)
        {
            r = r * -1;
        }
        r = r % (max - min) + min;
        return r;
    }    
    
    public String[] generatePseudoRandomHexadecimalStrings(int count)
    {
        String[] hashstring = new String[count];
        long ubound = 9223372036854775806L - (count + 1);
        long r = generatePseudoRandomNumber(0, ubound);
        try
        {
            for (int i = 0; i < hashstring.length; ++i)
            {
                BigInteger bint = new BigInteger(new Long((r + i)).toString()); // Radix / Base 16 / Hexadecimal
                hashstring[i] = String.format("%x", bint);
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
            return null;
        }
        return hashstring;
    }
    
    public String[] generatePseudoRandomHexadecimalStringsWithPrefix(int count, String prefix)
    {
        String[] hashstring = new String[count];
        long ubound = 9223372036854775806L - (count + 1);
        long r = generatePseudoRandomNumber(0, ubound);
        try
        {
            for (int i = 0; i < hashstring.length; ++i)
            {
                BigInteger bint = new BigInteger(new Long((r + i)).toString()); // Radix / Base 16 / Hexadecimal
                hashstring[i] = prefix + String.format("%x", bint);
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
            return null;
        }
        return hashstring;
    }    
    
    public static String[] generatePseudoRandomHexadecimalStrings(int count, Random random)
    {
        String[] hashstring = new String[count];
        long ubound = 9223372036854775806L - (count + 1);
        long r = generatePseudoRandomNumber(0, ubound, random);
        try
        {
            for (int i = 0; i < hashstring.length; ++i)
            {
                BigInteger bint = new BigInteger(new Long((r + i)).toString()); // Radix / Base 16 / Hexadecimal
                hashstring[i] = String.format("%x", bint);
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
            return null;
        }
        return hashstring;
    }    
    
    public static String[] generatePseudoRandomHexadecimalStringsWithPrefix(int count, Random random, String prefix)
    {
        String[] hashstring = new String[count];
        long ubound = 9223372036854775806L - (count + 1);
        long r = generatePseudoRandomNumber(0, ubound, random);
        try
        {
            for (int i = 0; i < hashstring.length; ++i)
            {
                BigInteger bint = new BigInteger(new Long((r + i)).toString()); // Radix / Base 16 / Hexadecimal
                hashstring[i] = prefix + String.format("%x", bint);
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
            return null;
        }
        return hashstring;
    }    
}
