/*
 * This Java source file is completely Free and Open-Source, 
 * released under the MIT License.
 *
 * Copyright (2012) Ashish Nawal Saharia (ashish.saharia@yahoo.co.in)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 */

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package net.infantai.util.common;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

/**
 *
 * @author Ashish (ashish.saharia@yahoo.co.in)
 */
public class SortingAndSearching
{
    
    public static Map<String, Integer> sortStringMapByValuesInteger(Map<String, Integer> unsortedMap, boolean ascending)
    {
        LinkedHashMap<String, Integer> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Integer, List<String>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<String, Integer>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<String, Integer> mapEntry = iterUnsorted.next();
            String unsortedMapKey = mapEntry.getKey();
            Integer unsortedMapValue = mapEntry.getValue();
            List<String> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Integer, List<String>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Integer, List<String>> mapEntry = iterValueKeys.next();
            Integer value = mapEntry.getKey();
            List<String> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                String key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }    
    
    public static Map<Integer, Integer> sortIntegerMapByValuesInteger(Map<Integer, Integer> unsortedMap, boolean ascending)
    {
        LinkedHashMap<Integer, Integer> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Integer, List<Integer>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<Integer, Integer>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<Integer, Integer> mapEntry = iterUnsorted.next();
            Integer unsortedMapKey = mapEntry.getKey();
            Integer unsortedMapValue = mapEntry.getValue();
            List<Integer> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Integer, List<Integer>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Integer, List<Integer>> mapEntry = iterValueKeys.next();
            Integer value = mapEntry.getKey();
            List<Integer> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                Integer key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }    
    
    public static Map<Long, Integer> sortLongMapByValuesInteger(Map<Long, Integer> unsortedMap, boolean ascending)
    {
        LinkedHashMap<Long, Integer> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Integer, List<Long>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<Long, Integer>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<Long, Integer> mapEntry = iterUnsorted.next();
            Long unsortedMapKey = mapEntry.getKey();
            Integer unsortedMapValue = mapEntry.getValue();
            List<Long> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Integer, List<Long>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Integer, List<Long>> mapEntry = iterValueKeys.next();
            Integer value = mapEntry.getKey();
            List<Long> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                Long key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }        
    
    public static Map<String, Long> sortStringMapByValuesLong(Map<String, Long> unsortedMap, boolean ascending)
    {
        LinkedHashMap<String, Long> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Long, List<String>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<String, Long>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<String, Long> mapEntry = iterUnsorted.next();
            String unsortedMapKey = mapEntry.getKey();
            Long unsortedMapValue = mapEntry.getValue();
            List<String> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Long, List<String>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Long, List<String>> mapEntry = iterValueKeys.next();
            Long value = mapEntry.getKey();
            List<String> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                String key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }    
    
    public static Map<Integer, Long> sortIntegerMapByValuesLong(Map<Integer, Long> unsortedMap, boolean ascending)
    {
        LinkedHashMap<Integer, Long> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Long, List<Integer>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<Integer, Long>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<Integer, Long> mapEntry = iterUnsorted.next();
            Integer unsortedMapKey = mapEntry.getKey();
            Long unsortedMapValue = mapEntry.getValue();
            List<Integer> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Long, List<Integer>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Long, List<Integer>> mapEntry = iterValueKeys.next();
            Long value = mapEntry.getKey();
            List<Integer> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                Integer key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }        
    
    public static Map<Long, Long> sortLongMapByValuesLong(Map<Long, Long> unsortedMap, boolean ascending)
    {
        LinkedHashMap<Long, Long> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Long, List<Long>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<Long, Long>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<Long, Long> mapEntry = iterUnsorted.next();
            Long unsortedMapKey = mapEntry.getKey();
            Long unsortedMapValue = mapEntry.getValue();
            List<Long> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Long, List<Long>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Long, List<Long>> mapEntry = iterValueKeys.next();
            Long value = mapEntry.getKey();
            List<Long> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                Long key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }        
    
    public static Map<String, Double> sortStringMapByValuesDouble(Map<String, Double> unsortedMap, boolean ascending)
    {
        LinkedHashMap<String, Double> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Double, List<String>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<String, Double>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<String, Double> mapEntry = iterUnsorted.next();
            String unsortedMapKey = mapEntry.getKey();
            Double unsortedMapValue = mapEntry.getValue();
            List<String> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Double, List<String>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Double, List<String>> mapEntry = iterValueKeys.next();
            Double value = mapEntry.getKey();
            List<String> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                String key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }        
    
    public static Map<Integer, Double> sortIntegerMapByValuesDouble(Map<Integer, Double> unsortedMap, boolean ascending)
    {
        LinkedHashMap<Integer, Double> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Double, List<Integer>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<Integer, Double>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<Integer, Double> mapEntry = iterUnsorted.next();
            Integer unsortedMapKey = mapEntry.getKey();
            Double unsortedMapValue = mapEntry.getValue();
            List<Integer> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Double, List<Integer>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Double, List<Integer>> mapEntry = iterValueKeys.next();
            Double value = mapEntry.getKey();
            List<Integer> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                Integer key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }    
    
    public static Map<Long, Double> sortLongMapByValuesDouble(Map<Long, Double> unsortedMap, boolean ascending)
    {
        LinkedHashMap<Long, Double> sortedByValuesMap = new LinkedHashMap<>();
        
        Map<Double, List<Long>> valueKeys;
        if (!ascending)
        {
            valueKeys = new TreeMap<>(Collections.reverseOrder());
        }
        else
        {
            valueKeys = new TreeMap<>();
        }
        
        Iterator<Map.Entry<Long, Double>> iterUnsorted = unsortedMap.entrySet().iterator();
        while (iterUnsorted.hasNext())
        {
            Map.Entry<Long, Double> mapEntry = iterUnsorted.next();
            Long unsortedMapKey = mapEntry.getKey();
            Double unsortedMapValue = mapEntry.getValue();
            List<Long> unsortedMapKeys = valueKeys.get(unsortedMapValue);
            if (unsortedMapKeys == null)
            {
                unsortedMapKeys = new ArrayList<>();
                valueKeys.put(unsortedMapValue, unsortedMapKeys);
            }
            unsortedMapKeys.add(unsortedMapKey);
        }
        
        Iterator<Map.Entry<Double, List<Long>>> iterValueKeys = valueKeys.entrySet().iterator();
        while (iterValueKeys.hasNext())
        {
            Map.Entry<Double, List<Long>> mapEntry = iterValueKeys.next();
            Double value = mapEntry.getKey();
            List<Long> keys = mapEntry.getValue();
            for (int i = 0; i < keys.size(); ++i)
            {
                Long key = keys.get(i);
                sortedByValuesMap.put(key, value);
            }
        }
        return sortedByValuesMap;
    }        

    public static boolean binarySearchInIntegerArray(int[] array, boolean isSortedInAscendingOrder, int valueToSearch)
    {
        boolean found = false;
        if (!isSortedInAscendingOrder)
        {
            Arrays.sort(array);
        }
        int index = Arrays.binarySearch(array, valueToSearch);
        if (index > 0)
        {
            found = true;
        }
        return found;
    }
    
    public static boolean binarySearchInLongArray(long[] array, boolean isSortedInAscendingOrder, long valueToSearch)
    {
        boolean found = false;
        if (!isSortedInAscendingOrder)
        {
            Arrays.sort(array);
        }
        int index = Arrays.binarySearch(array, valueToSearch);
        if (index > 0)
        {
            found = true;
        }
        return found;
    }            
    
    public static boolean binarySearchInIntegerList(List<Integer> list, boolean isSortedInAscendingOrder, int valueToSearch)
    {
        boolean found = false;
        if (!isSortedInAscendingOrder)
        {
            Collections.sort(list);
        }
        int index = Collections.binarySearch(list, valueToSearch);
        if (index > 0)
        {
            found = true;
        }
        return found;
    }     
    
    public static boolean binarySearchInLongList(List<Long> list, boolean isSortedInAscendingOrder, long valueToSearch)
    {
        boolean found = false;
        if (!isSortedInAscendingOrder)
        {
            Collections.sort(list);
        }
        int index = Collections.binarySearch(list, valueToSearch);
        if (index > 0)
        {
            found = true;
        }
        return found;
    }    
    
    public static int getInsertionIndexInSortedIntegerList(List<Integer> listSortedInAscendingOrder, Integer valueToSearch)
    {
        int insertionIndex = Collections.binarySearch(listSortedInAscendingOrder, valueToSearch);
        if (insertionIndex < 0)
        {
            insertionIndex = ~insertionIndex;
        }
        return insertionIndex;
    }    
    
    public static int getInsertionIndexInSortedLongList(List<Long> listSortedInAscendingOrder, Long valueToSearch)
    {
        int insertionIndex = Collections.binarySearch(listSortedInAscendingOrder, valueToSearch);
        if (insertionIndex < 0)
        {
            insertionIndex = ~insertionIndex;
        }
        return insertionIndex;
    }    
    
}
